<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: RMT.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">RMT.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * RMT.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Mar 1, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef COMPONENTS_CPP_UTILS_RMT_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define COMPONENTS_CPP_UTILS_RMT_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;driver/rmt.h&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div><div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="classRMT.html">   16</a></span>&#160;<span class="keyword">class </span><a class="code" href="classRMT.html">RMT</a> {</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <a class="code" href="classRMT.html#ab4e0f3b8ff01d7604d0bc52bc44c590f">RMT</a>(gpio_num_t pin, rmt_channel_t channel = RMT_CHANNEL_0);</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keyword">virtual</span> <a class="code" href="classRMT.html#a5b59083a872122d19e34d5585a06914f">~RMT</a>();</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classRMT.html#a29461fa2ff9900b5ddff5dd0ec35abb0">add</a>(<span class="keywordtype">bool</span> level, uint32_t duration);</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classRMT.html#acf727f6cdf9b357a320a19661f90e6c4">clear</a>();</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classRMT.html#af1b130bf271e12117511f75f6e08fcea">rxStart</a>();</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classRMT.html#a0f3abda595084f39bc5a524b468feeab">rxStop</a>();</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classRMT.html#a4dd6deb2c682661f70dd9b17519455e6">txStart</a>();</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classRMT.html#a5b4184c0472608379fdd868e3aa68e15">txStop</a>();</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classRMT.html#a0eef7f4df02df1f9e0f33cde2cb3ee1f">write</a>();</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    rmt_channel_t channel;</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    std::vector&lt;rmt_item32_t&gt; items;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keywordtype">int</span> bitCount = 0;</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;};</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* COMPONENTS_CPP_UTILS_RMT_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classRMT_html"><div class="ttname"><a href="classRMT.html">RMT</a></div><div class="ttdoc">Drive the RMT peripheral.</div><div class="ttdef"><b>Definition:</b> RMT.h:16</div></div>
<div class="ttc" id="classRMT_html_a0f3abda595084f39bc5a524b468feeab"><div class="ttname"><a href="classRMT.html#a0f3abda595084f39bc5a524b468feeab">RMT::rxStop</a></div><div class="ttdeci">void rxStop()</div><div class="ttdoc">Stop receiving.</div><div class="ttdef"><b>Definition:</b> RMT.cpp:60</div></div>
<div class="ttc" id="classRMT_html_a5b59083a872122d19e34d5585a06914f"><div class="ttname"><a href="classRMT.html#a5b59083a872122d19e34d5585a06914f">RMT::~RMT</a></div><div class="ttdeci">virtual ~RMT()</div><div class="ttdoc">Class destructor.</div><div class="ttdef"><b>Definition:</b> RMT.cpp:44</div></div>
<div class="ttc" id="classRMT_html_a0eef7f4df02df1f9e0f33cde2cb3ee1f"><div class="ttname"><a href="classRMT.html#a0eef7f4df02df1f9e0f33cde2cb3ee1f">RMT::write</a></div><div class="ttdeci">void write()</div><div class="ttdoc">Write the items out through the RMT.</div><div class="ttdef"><b>Definition:</b> RMT.cpp:88</div></div>
<div class="ttc" id="classRMT_html_a29461fa2ff9900b5ddff5dd0ec35abb0"><div class="ttname"><a href="classRMT.html#a29461fa2ff9900b5ddff5dd0ec35abb0">RMT::add</a></div><div class="ttdeci">void add(bool level, uint32_t duration)</div><div class="ttdoc">Add a level/duration to the transaction to be written.</div><div class="ttdef"><b>Definition:</b> RMT.cpp:101</div></div>
<div class="ttc" id="classRMT_html_acf727f6cdf9b357a320a19661f90e6c4"><div class="ttname"><a href="classRMT.html#acf727f6cdf9b357a320a19661f90e6c4">RMT::clear</a></div><div class="ttdeci">void clear()</div><div class="ttdoc">Clear any previously written level/duration pairs that have not been sent.</div><div class="ttdef"><b>Definition:</b> RMT.cpp:118</div></div>
<div class="ttc" id="classRMT_html_af1b130bf271e12117511f75f6e08fcea"><div class="ttname"><a href="classRMT.html#af1b130bf271e12117511f75f6e08fcea">RMT::rxStart</a></div><div class="ttdeci">void rxStart()</div><div class="ttdoc">Start receiving.</div><div class="ttdef"><b>Definition:</b> RMT.cpp:52</div></div>
<div class="ttc" id="classRMT_html_a5b4184c0472608379fdd868e3aa68e15"><div class="ttname"><a href="classRMT.html#a5b4184c0472608379fdd868e3aa68e15">RMT::txStop</a></div><div class="ttdeci">void txStop()</div><div class="ttdoc">Stop transmitting.</div><div class="ttdef"><b>Definition:</b> RMT.cpp:76</div></div>
<div class="ttc" id="classRMT_html_a4dd6deb2c682661f70dd9b17519455e6"><div class="ttname"><a href="classRMT.html#a4dd6deb2c682661f70dd9b17519455e6">RMT::txStart</a></div><div class="ttdeci">void txStart()</div><div class="ttdoc">Start transmitting.</div><div class="ttdef"><b>Definition:</b> RMT.cpp:68</div></div>
<div class="ttc" id="classRMT_html_ab4e0f3b8ff01d7604d0bc52bc44c590f"><div class="ttname"><a href="classRMT.html#ab4e0f3b8ff01d7604d0bc52bc44c590f">RMT::RMT</a></div><div class="ttdeci">RMT(gpio_num_t pin, rmt_channel_t channel=RMT_CHANNEL_0)</div><div class="ttdoc">Create a class instance.</div><div class="ttdef"><b>Definition:</b> RMT.cpp:19</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
